
!HttpRequest class methodsFor: '*ComanchePatch' stamp: 'SebastianSastre 1/15/2012 16:23'!
parseHttpHeader: string
	| dict key value start end more colonPos fieldDelims lastKey keyValueDelim crlf |
	dict := Dictionary new.
	crlf := String crlf.
	string isEmptyOrNil ifTrue: [^dict].
	fieldDelims := crlf asCharacterSet.
	keyValueDelim := $:.
	more := true.
	start := end := 1.
	lastKey := ''.
	[end := string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [end := string size. more := false]
		ifFalse: [end := end - 1].
	(end >= start and: [start < string size])
		ifTrue: [
			(string at: start) isSeparator
				ifTrue:
					[dict
						at: lastKey
						put: (dict at: lastKey), (string copyFrom: start to: end)]
				ifFalse:
					[colonPos := string indexOf: keyValueDelim startingAt: start.
					(colonPos > end or: [colonPos == 0])
						ifTrue:
							[key := (string copyFrom: start to: end) translateToLowercase.
							value := '']
						ifFalse:
							[key := (string copyFrom: start to: colonPos-1) translateToLowercase.
							value := (string copyFrom: colonPos+1 to: end) trimBoth]].
			key isEmpty
				ifFalse: [dict at: key put: value.
					lastKey := key.
					key := ''].
			start := string skipDelimiters: crlf startingAt: end+1].
	more] whileTrue.

	^dict! !

!HttpRequest methodsFor: '*ComanchePatch' stamp: 'SebastianSastre 1/15/2012 16:42'!
parseCookies: aString 
	"PRIVATE: Parse a string in the format:  
	Cookie: NAME1=OPAQUE_STRING1; NAME2=OPAQUE_STRING2 ..."

	| dict |
	dict := Dictionary new.
	(aString findTokens: ';') do: 
			[:pairStr | 
			| pair |
			pair := pairStr findTokens: '='.
			pair size > 0 
				ifTrue: 
					[| key value |
					key := pair first trimBoth asSymbol.
					value := pair size > 1 
						ifTrue:
							[pair second trimBoth]
						ifFalse:
							[nil].
					dict at: key put: value]
				ifFalse: 
					["self log: 'Cookie invalid pair format: ''' , pairStr , ''''"

					]].
	^dict! !
